/* 
 * Copyright (C) 1999-2004 Joachim Wieland <joe@mcknight.de>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.
 */

#include "ftp_main.h"

extern int ftp_reject(struct proxyinfo*);
extern int ftp_connect(struct proxyinfo*);
extern int ftp_accept(struct proxyinfo*);
extern char* ftp_log_replace_char(const char, struct proxyinfo*);
extern void ftp_log_cmd_to_target(struct cmdlogtarget*, struct proxyinfo*);
extern int ftp_allocate(struct proxyinfo*);
extern int ftp_deallocate(struct proxyinfo*);
extern int ftp_init_modules(void);
extern int ftp_add_configuration();
extern int ftp_reread_config_before(struct proxyinfo*);
extern int ftp_reread_config_after(struct proxyinfo*);

int main(int argc, char** argv) {
	struct protocolhandler proto_handler = { "ftp",
					       "jftpgw v"PACKAGE_VERSION,
					       ftp_reject,
					       ftp_connect,
					       ftp_accept,
					       ftp_log_cmd_to_target,
					       ftp_log_replace_char,
					       ftp_allocate,
					       ftp_deallocate,
					       ftp_init_modules,
					       ftp_add_configuration,
					       ftp_reread_config_before,
					       ftp_reread_config_after,
					       CONFPATH"/jftpgw.conf",
					       };
	return jproxygw_main(argc, argv, proto_handler);
}
