/* 
 * Copyright (C) 1999-2004 Joachim Wieland <joe@mcknight.de>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.
 */

/*
 * See 'log.c' for a detailed description.
 *
 * Copyright (C) 1998  Steven Young
 * Copyright (C) 1999  Robert James Kaes (rjkaes@flarenet.com)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#ifndef __JPROXYGW_LOG_H__
#define __JPROXYGW_LOG_H__

extern void jlog(int, const char *fmt, ...);

#define LOG_REPLACE_STRING                1
#define LOG_REPLACE_STRING_MALLOCED       2
#define LOG_REPLACE_CHAR                  3
#define LOG_REPLACE_UINT                  4
#define LOG_REPLACE_LUINT                 5
#define LOG_REPLACE_INT                   6
#define LOG_REPLACE_LINT                  7
#define LOG_REPLACE_FLOAT                 8

#define LOG_STRFTIME_LENGTH      64

/* used:
 *          a A b C d (e) f F h H i I l L m n p P r R s t T u v        */

struct loginfo_st {
	int syslog;
	char* syslog_facility;
	int debuglevel;
	char* logf_name;
	FILE* logf;
	int servertype;
	int multithread;
	char* binaryname;
	struct cmdlogtarget {
		/* list of opened logfiles */
		char* logf_name;
		char* specs;
		FILE* logf;
		char* style;
		struct cmdlogtarget* next;
	} *cmdlogfiles, *cmdlogdirs;
};

union log_replace_un {
	const char* replace_str;
	char replace_char;
	unsigned int replace_uint;
	unsigned long int replace_luint;
	signed int replace_int;
	signed long int replace_lint;
	float replace_float;
};

FILE* open_logfile(const char*);

void log_cmd(struct proxyinfo*);
int log_init(struct proxyinfo*);
int log_init_connect(struct proxyinfo* pi);
void log_deinit(struct proxyinfo*);
int log_reinit(struct proxyinfo*);

int incommandpattern(const char *haystack, const char *needle);
char* log_replace_line(const char*, struct proxyinfo*);
char* log_replace(int, union log_replace_un);


#endif
